	.686
	.model flat, stdcall
	option casemap :none

	include \masm32\include\ntdll.inc
	includelib \masm32\lib\ntdll.lib
	
	include \masm32\include\kernel32.inc
	includelib \masm32\lib\kernel32.lib

	include \masm32\include\user32.inc
	includelib \masm32\lib\user32.lib

	includelib \masm32\lib\masm32.lib

	include Avrf.inc
	
.data
$Tnunk1	CHAR "RtlGetVersion",0
$DLL1	WCHAR "n","t","d","l","l",".","d","l","l",0

align 4
Dll1Thunks	RTL_VERIFIER_THUNK_DESCRIPTOR <$Tnunk1, 0, xApi>
			PVOID NULL

DLL1			RTL_VERIFIER_DLL_DESCRIPTOR <$DLL1, 0, 0, Dll1Thunks>
			PVOID NULL

Avrf			RTL_VERIFIER_PROVIDER_DESCRIPTOR_EX <sizeof(RTL_VERIFIER_PROVIDER_DESCRIPTOR), DLL1, ?, ?, ?, ?, ?, ?, ?, ?>

.code
xApi proc Version:PRTL_OSVERSIONINFOW
	push Version
	Call Dll1Thunks.ThunkOldAddress
	.if !Eax
		mov ecx,Version
		assume ecx:PRTL_OSVERSIONINFOW
		mov [ecx].dwMajorVersion,5
		mov [ecx].dwMinorVersion,1
	.endif
	ret
xApi endp

Startup proc DllHandle:HANDLE, Reason:ULONG, Context:PVOID
	.if Reason == DLL_PROCESS_VERIFIER
		assume fs:nothing
		mov eax,fs:[TEB.Peb]
		assume eax:PPEB
		mov ecx,Context
		cmp [eax].NtMajorVersion,5
		mov D[ecx],offset Avrf
		.if (Zero? && ([Eax].NtMinorVersion > 1)) || (Carry?)
			add Avrf._Length,sizeof(RTL_VERIFIER_PROVIDER_DESCRIPTOR_EX) - sizeof(RTL_VERIFIER_PROVIDER_DESCRIPTOR)
		.endif
	.endif
	mov eax,TRUE
Exit:
	ret
Startup endp
end Startup